@ECHO OFF
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION

SET neededfiles=dsfo.exe dsfi.exe dumphex.exe
FOR %%A IN (%neededfiles%) DO IF NOT EXIST %%A ECHO Missing file: %%A& GOTO :ERROR1

ECHO CHPTNORD.CMD Small batch to re-arrange order of partition entries 
ECHO on existing MBR on PhysicalDrives - by jaclaz - release 0.02 ALPHA 
ECHO.
IF %1.==/?. ECHO NO help available, nor needed. &GOTO :EOF

CALL :MBRVIEWI
IF %DriveNum%.=="A suffusion of yellow". CALL :error %DriveNum%&GOTO :EOF
ECHO Current partition order is 1234, you can change it.
IF EXIST now.$$$ CALL :Error IF EXIST now.$$$&GOTO :EOF
SET New_Order=1234
SET /P New_Order= Please enter a four number sequence or ENTER to leave it as is:
IF NOT %New_Order%.==1234. ECHO order changed!&CALL :change_order
CALL :Write_MBR
GOTO :EOF

:change_order
ECHO.
SET Part1st=%New_order:~0,1%
SET Part2nd=%New_order:~1,1%
SET Part3rd=%New_order:~2,1%
SET Part4th=%New_order:~3,1%
SET /A New_Order=%Part1st%+%Part2nd%+%Part3rd%+%Part4th%
IF NOT %New_Order% equ 10 CALL :Error %New_Order% is NOT 10 &GOTO :EOF
CALL :Do_parts
GOTO :EOF

:Do_parts
SET previous_mbr=%Target%
IF NOT EXIST %previous_mbr% CALL :Error IF NOT EXIST %previous_mbr%&GOTO :EOF
IF EXIST now_head.$$$ CALL :Error IF EXIST now_head.$$$&GOTO :EOF
IF EXIST now_data1.$$$ CALL :Error IF EXIST now_data1.$$$&GOTO :EOF
IF EXIST now_data2.$$$ CALL :Error IF EXIST now_data2.$$$&GOTO :EOF
IF EXIST now_data3.$$$ CALL :Error IF EXIST now_data3.$$$&GOTO :EOF
IF EXIST now_data4.$$$ CALL :Error IF EXIST now_data4.$$$&GOTO :EOF
IF EXIST now_tail.$$$ CALL :Error IF EXIST now_tail.$$$&GOTO :EOF

dsfo %previous_mbr% 0 446 now_head.$$$
dsfo %previous_mbr% 446 16 now_data1.$$$
dsfo %previous_mbr% 462 16 now_data2.$$$
dsfo %previous_mbr% 478 16 now_data3.$$$
dsfo %previous_mbr% 494 16 now_data4.$$$
dsfo %previous_mbr% 510 2 now_tail.$$$

Copy /b now_head.$$$+now_data%Part1st%.$$$+now_data%Part2nd%.$$$+now_data%Part3rd%.$$$+now_data%Part4th%.$$$+now_tail.$$$ now.$$$
SET Source=now.$$$
CALL :MBRFILEVIEW
GOTO :EOF

:MBRVIEWI
IF NOT DEFINED Source (
ECHO Getting info from a MBR, Physicaldrive numbering starts with 0
SET /P Source= Please enter a PhysicalDrive number: 
)

IF %Source% Geq 0 IF %Source% Leq 9 (
SET DriveNum=%Source%
SET Source=\\.\PHYSICALDRIVE%Source%
) ELSE (
SET %DriveNum="A suffusion of yellow"
GOTO :EOF
)
IF NOT DEFINED Target SET Target=MBRTEMP.$$$
SET /A Offset=0
Set /A Length=512
ECHO Creating a MBR from %Source% with dsfo.exe:
IF EXIST %Target% del %Target%
dsfo %Source% %Offset% %Length% %Target%
IF NOT EXIST %Target% SET DriveNum="A suffusion of yellow"&GOTO :EOF
SET RSource=%Source%  Temporary file: %Target%
Set Source=%Target%


:MBRFILEVIEW
ECHO Dumping partition entries with DumpHex Version 1.0.1 
ECHO Copyright (c) 2003 Robert Bachmann
SET /A Length=16
SET /A VPartnum=1
SET /A Offset=0x1BE

:LoopEntries
SET newline=
REM DUMMYSPACE A B C D E F G H  I  J  K  L  M  N  O  P
FOR /F "tokens=2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17 delims=: " %%A IN ('dumphex /S%Offset% /L%Length% /w16 /nc %Source% 2^>nul') DO (
SET VActive=%%A
SET VPartType=%%E
SET /A VBHd=0x%%B
SET /A VBSecCyl=0x%%C%%D
SET /A VEHd=0x%%F
SET /A VESecCyl=0x%%G%%H
SET /A VStartLBA=0x%%L%%K%%J%%I
SET /A VSectorsLBA=0x%%P%%O%%N%%M
)

SET Powers=32768 16384 8192 4096 2048 1024 512 256 128 64 32 16 8 4 2 1


CALL :DEC2BIN %VBSecCyl%
SET VBCyl=%BINnum:~0,2%%BINnum:~8,8%
SET VBSec=%BINnum:~2,6%

CALL :DEC2BIN %VESecCyl%
SET VECyl=%BINnum:~0,2%%BINnum:~8,8%
SET VESec=%BINnum:~2,6%

SET Powers=512 256 128 64 32 16 8 4 2 1

CALL :BIN2DEC %VBCyl% 10
SET VBCyl=%DECnum%

CALL :BIN2DEC %VECyl% 10
SET VECyl=%DECnum%

SET Powers=32 16 8 4 2 1

CALL :BIN2DEC %VBSec% 6
SET VBSec=%DECnum%

CALL :BIN2DEC %VESec% 6
SET VESec=%DECnum%

FOR %%A IN ( 
VPartnum.6
VParttype.11
VActive.16
VBCyl.23
VBHd.27
VBSec.32
VECyl.39
VEHd.43
VESec.48
VStartLBA.60
VSectorsLBA.74
) DO (
CALL :adddata newline %%~nA %%~xA
)
IF NOT DEFINED Target SET RSource=%Source%
For %%A IN (1 2 3 4) DO IF NOT DEFINED Line%%A SET LINE%%A=                                                               
SET Linea=Source:%RSource%
SET Lineb=Ŀ
SET Linec=Part TypeBoot  Begin   CHS     End   CHS    LBA Start  LBA Sectors 
SET Lined=  #           BCyl BHdBSec ECyl EHdESec                        
SET Linee=Ĵ
SET Line%Vpartnum%=%newline%
SET Linef=Ĵ
SET Lineg=
CLS
For %%A IN (a b c d e 1 f 2 f 3 f 4 g) DO ECHO !Line%%A!
IF NOT %VPartnum%==4 (
SET /A VPartnum=%VPartnum%+1
SET /A Offset=%Offset%+16
GOTO :LoopEntries
)
REM IF EXIST MBRTEMP.$$$ DEL MBRTEMP.$$$
GOTO :EOF

:DEC2BIN
SET BINnum=
SET DECnum=%1
SET /A Val32768=%DECnum% / 32768
SET /A Mod32768=%DECnum% %% 32768
FOR %%A in (%Powers%) DO CALL:BINcalc %%A
FOR %%A in (%Powers%) DO SET BINnum=!BINnum!!Val%%A!
GOTO :EOF

:BINcalc
IF %1==1 GOTO :EOF
SET /A Div=%1 /2
SET /A Val%Div%=!Mod%1! / %Div%
SET /A Mod%Div%=!Mod%1! %% %Div%
GOTO :EOF

:BIN2DEC
SET DECnum=
SET BINnum=%1
SET BINLength=%2
Set Counter=0
FOR %%A IN (%Powers%) DO (
CALL :DECcalc %%A
SET /A Counter=!Counter!+1
)
FOR %%A IN (%Powers%) DO SET /A DECnum=!DECnum!+!Digit%%A!*%%A
GOTO :EOF

:DECcalc
SET digit%1=!BINNum:~%Counter%,1!
IF %Counter%==%BINLength% GOTO :EOF
GOTO :EOF

:DEC2hex
SET DECnum=%1
SET Numdig=%2
SET HEXnum=
SET Powers=268435456 16777216 1048576 65536 4096 256 16 1
::=======================================================
::| WARNING! Limit is 2147483647 i.e. 7FFFFFF  WARNING! |
::=======================================================
SET /A Limit=%DECnum%/16
IF %Limit% LSS 0 ECHO Out of Range &GOTO :EOF
SET /A Val268435456=%DECnum% / 268435456
SET /A Mod268435456=%DECnum% %% 268435456
FOR %%A in (%Powers%) DO CALL:HEXcalc %%A
FOR %%A in (%Powers%) DO CALL:HEXchar %%A
FOR %%A in (%Powers%) DO SET Hexnum=!Hexnum!!Val%%A!

SET /A Length=8
SET HexnumF=%Hexnum%
CALL :RemoveLead

GOTO :EOF

:RemoveLead
Set/A Length=%Length%-2
IF %HexnumF:~0,2%==00 set HEXnumF=!HexnumF:~-%Length%!&GOTO :RemoveLead
SET HexnumF=!Hexnum:~-%NumDig%!
SET Hexnum=%HexnumF:~6,2%%HexnumF:~4,2%%HexnumF:~2,2%%HexnumF:~0,2%
GOTO :EOF

:HEXcalc
IF %1==1 GOTO :EOF
SET /A Div=%1 /16
SET /A Val%Div%=!Mod%1! / %Div%
SET /A Mod%Div%=!Mod%1! %% %Div%
GOTO :EOF

:HEXchar
IF !Val%1!==10 SET Val%1=A
IF !Val%1!==11 SET Val%1=B
IF !Val%1!==12 SET Val%1=C
IF !Val%1!==13 SET Val%1=D
IF !Val%1!==14 SET Val%1=E
IF !Val%1!==15 SET Val%1=F
GOTO :EOF

:adddata
if %3.==. GOTO :EOF
set templine=%1
set thisline=!%templine%!
set pad=%2
set pad=!%pad%!
set sepoffset=%3
set sepoffset=%sepoffset:.=%
:dataloop
SET templine=%thisline%%pad%
set pad= %pad%
IF NOT "!templine:~%sepoffset%,1!"=="" goto :dataloop
SET %1=%templine%
GOTO :EOF

:Write_MBR
ECHO Following command is:
ECHO dsfi \\.\Physicalddrive%DriveNum% 0 512 now.$$$
::******************************************************
REM UNREM FOLLOWING LINE
REM dsfi \\.\Physicalddrive%DriveNum% 0 512 now.$$$
REM UNREM ABOVE LINE
::******************************************************
ECHO.
SET Clean_the_mess=
SET /P Clean_the_mess=DO YOU WANT TO CLEAN TEMPORARY FILES? (Y/N)
IF /I %Clean_the_mess%.==Y. CALL :Clean_the_mess
GOTO :EOF

:Clean_the_mess
FOR %%? IN (
now
now_head
now_data1
now_data2
now_data3
now_data4
now_tail
mbrtemp
) DO IF EXIST %%?.$$$ del %%?.$$$
GOTO :EOF



:error
ECHO An error has occurred "%*"
GOTO :EOF

:error1
ECHO Please add the missing file in the same directory where %~nx0 is
GOTO :EOF

:END
